function Pjt = getIndi_p2(state1,state2,a,a_eff,hlr, nodeID)
% get the individual transition probability for each habitat node
% state1 is the state at t
% state2 is the state at t+1
% a is the action
% a_eff is the action efficiency
% hlr is the habitat loss rate vector of 1*8
% nodeID is the ID of habitat node i, ranges from 1-8
Pjt=zeros(1,length(state1));
for i=1:length(state1)
    if (any(nodeID{a}==i)==0) % not under protection
        if (state1(i)==1 && state2(i)==1)
        Pjt(i)=1-hlr(i);
        elseif (state1(i)==1 && state2(i)==0)
        Pjt(i)=hlr(i);
        elseif (state1(i)==0 && state2(i)==0)
        Pjt(i)=1;    
        end
    else
        if (state1(i)==1 && state2(i)==1)
        Pjt(i)=1-hlr(i)+hlr(i)*a_eff;
        elseif (state1(i)==1 && state2(i)==0)
        Pjt(i)=hlr(i)*(1-a_eff);
        elseif (state1(i)==0 && state2(i)==0)
        Pjt(i)=1;    
        end % don't have recover rate
    end

    
end

